<template>
  <div class="q-mt-lg-lg-xs">
    <q-spinner-cube
      class="fixed-center"
      color="primary"
      size="5em"
      v-if="isLoadingProducts"
    />
    <q-page v-else>
      <q-list>
        <div v-for="product in products" :key="product.id">
          <q-slide-item @right="(details) => { onSwipeRight(details, product) }" right-color="red">
            <template v-slot:right>
              <div class="row items-center">
                <q-icon name="delete"/>
              </div>
            </template>
            <q-item>
              <q-item-section avatar>
                <q-item-label>
                  <q-icon name="crop_original" size="lg"/>
                </q-item-label>
              </q-item-section>
              <q-item-section>
                <q-item-label lines="1">{{ product.name }}</q-item-label>
                <q-item-label caption>{{ product.price }} PLN</q-item-label>
                <q-item-label caption v-if="product.amount_in_basket > 0">
                  Already {{ product.amount_in_basket }} in basket
                </q-item-label>
                <q-item-label caption v-else>
                  Tap basket to add
                </q-item-label>
              </q-item-section>
              <q-item-section side>
                <div class="text-grey-8 q-gutter-xs">
                  <q-btn push size="md" dense round flat icon="add_shopping_cart" @click="handleAddToCartTapped(product)"/>
                  <q-btn size="md" dense round flat icon="more_vert" @click="() => { handleAddEditTapped(product) }"/>
                </div>
              </q-item-section>
            </q-item>
          </q-slide-item>
        </div>
      </q-list>
      <q-page-sticky position="bottom-right" :offset="[18, 18]">
        <q-btn push fab icon="add" color="accent" @click="() => { handleAddEditTapped() }"/>
      </q-page-sticky>
    </q-page>
  </div>
</template>

<script>
import { productRepository } from 'src/public/ProductRepository'
import { pushClient } from 'src/public/PushClient'

export default {
  name: 'ProductList',
  data: () => {
    return {
      isAddProductDialogVisible: false,
      isLoadingProducts: true,
      products: []
    }
  },
  methods: {
    async onSwipeRight ({ reset }, product) {
      await productRepository.removeById(product.id)
      this.products = this.products.filter((p) => p.id !== product.id)
      this.$q.notify({
        type: 'positive',
        message: `Removed product ${product.name}`
      })
      reset()
    },
    async addOrEditProduct (product, id) {
      const createdProduct = await productRepository.save(product, id)
      await pushClient.sendPushNotification(createdProduct)
    },
    async handleAddToCartTapped (product) {
      product.amount_in_basket++
      await productRepository.save(product, product.id)
    },
    handleAddEditTapped (product) {
      this.$router.push({
        name: 'add',
        query: {
          id: product?.id
        }
      })
    }
  },
  async mounted () {
    this.$root.$on('on-product-submitted', this.addOrEditProduct)
    this.products = await productRepository.getAll()
    this.isLoadingProducts = false
  }
}
</script>

<style scoped>

</style>
